Package com.io7m.jregions.core.parameterized.volumes

# Class PVolumeI.Builder<S>

java.lang.Object
com.io7m.jregions.core.parameterized.volumes.PVolumeI.Builder<S>

Enclosing class:
  PVolumeI<S>

    public static final class PVolumeI.Builder<S>
    extends java.lang.Object

Builds instances of type `PVolumeI`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `PVolumeI<S>` | `build()` | Builds a new `PVolumeI`.
  `PVolumeI.Builder<S>` | `from​(PVolumeIType<S> instance)` | Fill a builder with attribute values from the provided `com.io7m.jregions.core.parameterized.volumes.PVolumeIType` instance.
  `PVolumeI.Builder<S>` | `from​(VolumeValuesIType instance)` | Fill a builder with attribute values from the provided `com.io7m.jregions.core.unparameterized.volumes.VolumeValuesIType` instance.
  `PVolumeI.Builder<S>` | `setMaximumX​(int maximumX)` | Initializes the value for the `maximumX` attribute.
  `PVolumeI.Builder<S>` | `setMaximumY​(int maximumY)` | Initializes the value for the `maximumY` attribute.
  `PVolumeI.Builder<S>` | `setMaximumZ​(int maximumZ)` | Initializes the value for the `maximumZ` attribute.
  `PVolumeI.Builder<S>` | `setMinimumX​(int minimumX)` | Initializes the value for the `minimumX` attribute.
  `PVolumeI.Builder<S>` | `setMinimumY​(int minimumY)` | Initializes the value for the `minimumY` attribute.
  `PVolumeI.Builder<S>` | `setMinimumZ​(int minimumZ)` | Initializes the value for the `minimumZ` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final PVolumeI.Builder<S> from​(VolumeValuesIType instance)
    Fill a builder with attribute values from the provided `com.io7m.jregions.core.unparameterized.volumes.VolumeValuesIType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVolumeI.Builder<S> from​(PVolumeIType<S> instance)
    Fill a builder with attribute values from the provided `com.io7m.jregions.core.parameterized.volumes.PVolumeIType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setMinimumX

    public final PVolumeI.Builder<S> setMinimumX​(int minimumX)
    Initializes the value for the `minimumX` attribute.
    Parameters:
      `minimumX` - The value for minimumX
    Returns:
      `this` builder for use in a chained invocation

  - ### setMaximumX

    public final PVolumeI.Builder<S> setMaximumX​(int maximumX)
    Initializes the value for the `maximumX` attribute.
    Parameters:
      `maximumX` - The value for maximumX
    Returns:
      `this` builder for use in a chained invocation

  - ### setMinimumY

    public final PVolumeI.Builder<S> setMinimumY​(int minimumY)
    Initializes the value for the `minimumY` attribute.
    Parameters:
      `minimumY` - The value for minimumY
    Returns:
      `this` builder for use in a chained invocation

  - ### setMaximumY

    public final PVolumeI.Builder<S> setMaximumY​(int maximumY)
    Initializes the value for the `maximumY` attribute.
    Parameters:
      `maximumY` - The value for maximumY
    Returns:
      `this` builder for use in a chained invocation

  - ### setMinimumZ

    public final PVolumeI.Builder<S> setMinimumZ​(int minimumZ)
    Initializes the value for the `minimumZ` attribute.
    Parameters:
      `minimumZ` - The value for minimumZ
    Returns:
      `this` builder for use in a chained invocation

  - ### setMaximumZ

    public final PVolumeI.Builder<S> setMaximumZ​(int maximumZ)
    Initializes the value for the `maximumZ` attribute.
    Parameters:
      `maximumZ` - The value for maximumZ
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public PVolumeI<S> build()
    Builds a new `PVolumeI`.
    Returns:
      An immutable instance of PVolumeI
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing